#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_magic_array_config.h"
#include "FileEncrypt.h"
std::auto_ptr<M_magic_array_config> M_magic_array_config::msSingleton(nullptr);

int M_magic_array_config::GetCount()
{
	return (int)mMapData.size();
}

const M_magic_array_configData* M_magic_array_config::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int64_t, M_magic_array_configData>& M_magic_array_config::GetMapData()
{
	return mMapData;
}

void M_magic_array_config::Reload()
{
	mMapData.clear();
	Load();
}

void M_magic_array_config::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_magic_array_configData data;
		{
			int64_t temp = 0;
			const char* str = element->Attribute("ID");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mID = temp;
		}
		data.mlevel = element->IntAttribute("level");
		{
			const char* up_cost = element->Attribute("up_cost");
			std::vector<std::string> vecup_cost;
			boost::split(vecup_cost, up_cost, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecup_cost.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecup_cost[i].c_str(), &temp))
				{
					data.mup_cost.push_back(temp);
				}
			}
		}
		{
			const char* atk_cost = element->Attribute("atk_cost");
			std::vector<std::string> vecatk_cost;
			boost::split(vecatk_cost, atk_cost, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecatk_cost.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecatk_cost[i].c_str(), &temp))
				{
					data.matk_cost.push_back(temp);
				}
			}
		}
		{
			const char* un_lock_award = element->Attribute("un_lock_award");
			std::vector<std::string> vecun_lock_award;
			boost::split(vecun_lock_award, un_lock_award, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecun_lock_award.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecun_lock_award[i].c_str(), &temp))
				{
					data.mun_lock_award.push_back(temp);
				}
			}
		}
		data.matk = element->IntAttribute("atk");
		data.mhp = element->IntAttribute("hp");
		data.micon = element->Attribute("icon");
		data.mm_stone = element->Attribute("m_stone");
		data.mmgc_stone = element->FloatAttribute("mgc_stone");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_magic_array_config::Load()
{
	Load("../Config/M_magic_array_config.xml");
}

M_magic_array_config* M_magic_array_config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_magic_array_config());
	}
	return msSingleton.get();
}
